//-----------------------------------------------------------------------------
// Project:   Code for 'Using TStream to save application data' session
//            UK BUG Midlands Meeting 25/10/2002
// Module:    Main form for streaming single object example
// Compiler:  Delphi 5+
// Author:    Mark Warriner                         mark@cybermunch.com
// Copyright: New Transducer Ltd. UK
//-----------------------------------------------------------------------------
unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, MyClass,
  StdCtrls, Buttons, Grids;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label_x: TLabel;
    Edit_i: TEdit;
    Edit_x: TEdit;
    Label2: TLabel;
    Edit_S: TEdit;
    Button_Save: TButton;
    Button_Load: TButton;
    Button_SaveClipboard: TButton;
    Button_LoadClipboard: TButton;
    BitBtn1: TBitBtn;
    procedure Button_SaveClick(Sender: TObject);
    procedure Button_LoadClick(Sender: TObject);
    procedure Button_SaveClipboardClick(Sender: TObject);
    procedure Button_LoadClipboardClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
//------------------------------------------------------------------------------
{$R *.DFM}
//------------------------------------------------------------------------------
procedure TForm1.Button_SaveClick(Sender: TObject);
var
  FS: TFileStream;
  MyObj: TMyClass;
begin
  MyObj:= TMyClass.Create;
  MyObj.i:= StrToInt(Edit_i.Text);
  MyObj.x:= StrToFloat(Edit_x.Text);
  MyObj.Str:= Edit_S.Text;
  FS:= TFileStream.Create('MySavedClass.sc', fmCreate);
  try
    MyObj.SaveToStream(FS);
  finally
    FS.Free;
    MyObj.Free;
  end;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button_LoadClick(Sender: TObject);
var
  FS: TFileStream;
  MyObj: TMyClass;
  Str: String;
begin
  MyObj:= TMyClass.Create;
  FS:= TFileStream.Create('MySavedClass.sc', fmOpenRead);
  try
    MyObj.LoadFromStream(FS);
    Edit_i.Text:= IntToStr(MyObj.i);
    Edit_x.Text:=  FloatToStr(MyObj.x);
    Edit_S.Text:=  MyObj.Str;
    FmtStr(Str, 'Object loaded from file MySavedClass.sc with properties'
                  +#10+' i=%d, '+#10+' x=%n, '+#10+' s=%s',
           [MyObj.i, MyObj.x, MyObj.Str]);
    ShowMessage(Str);
  finally
    FS.Free;
    MyObj.Free;
  end;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button_SaveClipboardClick(Sender: TObject);
var
  MS: TMemoryStream;
  MyObj: TMyClass;
begin
  // save to clipboard
  MyObj:= TMyClass.Create;
  MyObj.i:= StrToInt(Edit_i.Text);
  MyObj.x:= StrToFloat(Edit_x.Text);
  MyObj.Str:= Edit_S.Text;
  MS:= TMemoryStream.Create;
  try
    MyObj.SaveToStream(MS);
    WriteMyClassToClipboard(MS);
  finally
    MS.Free;
    MyObj.Free;
  end;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button_LoadClipboardClick(Sender: TObject);
var
  MS: TMemoryStream;
  MyObj: TMyClass;
begin
  // load from clipboard
  MyObj:= TMyClass.Create;
  MS:= TMemoryStream.Create;
  try
    ReadMyClassFromClipboard(MS);
    MyObj.LoadFromStream(MS);
    Edit_i.Text:= IntToStr(MyObj.i);
    Edit_x.Text:=  FloatToStr(MyObj.x);
    Edit_S.Text:=  MyObj.Str;
  finally
    MS.Free;
    MyObj.Free;
  end;
end;
//------------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;
//------------------------------------------------------------------------------

end.
